var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { escapeRegexChars } from "../helpers/strings";
import { KeyValueType } from "./KeyValueType";
var RegexKeyValueType = /** @class */ (function (_super) {
    __extends(RegexKeyValueType, _super);
    function RegexKeyValueType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RegexKeyValueType.mongoSelectorFor = function (value) {
        return { $regex: value.regex, $options: value.options };
    };
    RegexKeyValueType.prototype.getSuggestions = function (prefix) {
        var _this = this;
        var display = function (val) { return _this.display(_this.parseString(val)); };
        return [
            { display: display("abc"), value: "abc", extra: "Einfache Suche" },
            { display: display('"Hallo Welt!"'), value: '"Hallo Welt!"', extra: "\"...\" für Leerzeichen" },
            { display: display("/[a-c0-9]/i"), value: "/[a-c0-9]/i", extra: "RegEx" },
        ];
    };
    RegexKeyValueType.prototype.parseString = function (val) {
        var text = val.trim();
        if (text === "") {
            return undefined;
        }
        var match = text.match(/^\/(.*)\/([a-z]*)$/);
        if (match) {
            try {
                // tslint:disable-next-line:no-unused-expression as the expression is used for error checking
                new RegExp(match[1], match[2]);
                return {
                    text: text,
                    printRegex: jQuery("<div>").text(match[1]).html(),
                    regex: match[1],
                    options: match[2],
                };
            }
            catch (e) {
                // escape below like non-regex strings
            }
        }
        return {
            text: text,
            regex: escapeRegexChars(text),
            options: "i",
        };
    };
    RegexKeyValueType.prototype.checkValue = function (val) {
        if (typeof val.text === "string"
            && (val.printRegex === undefined || typeof val.printRegex === "string")
            && typeof val.regex === "string"
            && typeof val.options === "string") {
            return val;
        }
        else {
            return undefined;
        }
    };
    RegexKeyValueType.prototype.display = function (value) {
        if (value.printRegex) {
            return { html: "<code>/</code>" + value.printRegex + "<code>/" + value.options + "</code>" };
        }
        else {
            return { text: value.text };
        }
    };
    RegexKeyValueType.prototype.editText = function (value) {
        if (value.text.includes(" ")) {
            return "\"" + value.text.replace(/\\/g, "\\\\").replace(/"/g, "\\\"") + "\"";
        }
        else {
            return value.text;
        }
    };
    return RegexKeyValueType;
}(KeyValueType));
export default RegexKeyValueType;
